var mOpenAutoLoadData = false;
var startDtPicker, endDtPicker;
var startDate, endDate;
var onResultSucceed = false;

var app = new Vue({
    el: '#app',
    data: {
        currDate: '',
        hasBind: false,
        carNum: '',
        electricTension: '', // 电瓶电压 V
        engineWeight: '', // 发动机负荷(%)
        coolingLiquidTemperature: '', // 冷却液温度(℃)
        instantOilWear: '', // 瞬时油耗(ML/H)
        inletTemperature: 0, // 进气温度(℃)
        airFlux: 0, // 空气流量(G/S)
        inletPressure: 0, // 进气歧管绝对压力(KPA)
        throttleValvePlace: 0, // 节气门位置(%)
        fuelOilPressure: 0, // 燃油压力计量(KPA)
        VINCode: '',// VIN码
        totalMileage: 0,
        continuousMileage: 0,
        percentageOfOil: 0,
        testData: '',
        rev: 0, // 转速
        speed: 0, // 车速
        gaugeHtml: '' // 仪表进度条
    },
    methods: {
        onBack: function (event) {
            EasymsPlugin.onBack();
        },
		
		toFaultDetect: function () {
			window.location.href = '../faultdetect/faultdetect.html?carnum=' + this.carNum
		},
		
        selectDate: function (event) {
            if (!startDtPicker) {
                startDtPicker = new mui.DtPicker({ type: 'datetime', value: new Date().Format('yyyy-MM-dd 00:00'), endDate: new Date() });
            }
            startDtPicker.show(function (selectItems) {
                console.log(selectItems.value);
                startDate = selectItems.value + ':00';
                if (!endDtPicker) {
                    endDtPicker = new mui.DtPicker({ type: 'datetime', endDate: new Date() });
                }
                endDtPicker.show(function (selectItems) {
                    console.log(selectItems.value);
                    endDate = selectItems.value + ':00';
                    EasymsPlugin.invoke('ECS_BusinessService', 'QueryGPSReportList',
                        'System.Int32|System.String|System.DateTime|System.DateTime',
                        '50|' + app.$data.carNum + '|' + startDate + '|' + endDate,
                        'onSearchResult');
                });
            });
            document.querySelector(".mui-dtpicker-title").innerText = '开始时间';
        },
        getCircleHtml: function (value, text, color) {
            var v = (255 - value / 100 * 255).toFixed(2);
            var x = (46 + Math.sin(value * Math.PI / 50).toFixed(2) * 40).toFixed(2);
            var y = (46 - Math.cos(value * Math.PI / 50).toFixed(2) * 40).toFixed(2);

            return '<div class="circle-progress">'
                + '<svg class="circle" xmlns="http://www.w3.org/2000/svg">'
                + '<circle cx="50%" cy="50%" r="40%" stroke-dashoffset="' + v + '%" stroke="' + color + '"></circle>'
                + '</svg>'
                + '<svg class="circle2">'
                + '<circle cx="50%" cy="50%" r="40%"></circle>'
                + '</svg>'
                + '<div class="circle3" style="left:' + x + 'px;top:' + y + 'px; background-color: '
                + color + '; box-shadow: 0px 0px 10px ' + color + ';"></div>'
                + '<span class="circle-text">' + text + '</span>'
                + '</div>';
        },
        getGaugeHtml: function (value) {
            var v = (255 - value / 100 * 182).toFixed(2);
            var x = (76 + Math.sin(Math.PI * (value * 0.0146111 - 131 / 180)).toFixed(2) * 64).toFixed(2);
            var y = (76 - Math.cos(Math.PI * (value * 0.0146111 - 131 / 180)).toFixed(2) * 64).toFixed(2);

            return '<div class="progress-gauge">'
                + '<svg class="circle-gauge" xmlns="http://www.w3.org/2000/svg">'
                + '<circle cx="50%" cy="50%" r="40%" stroke-dashoffset="' + v + '%"></circle>'
                + '</svg>'
                + '<svg class="circle-gauge2">'
                + '<circle cx="50%" cy="50%" r="40%"></circle>'
                + '</svg>'
                + '<div class="circle-gauge3" style="left: ' + x + 'px; top: ' + y + 'px;"></div>'
                + '</div>';
        },
        onResult: function (res) {
            var result = res;//JSON.parse(res);
            onResultSucceed = (result.SucceedFlag == 0);
            if (result.SucceedFlag != 0) {
                //mui.alert(result.ErrorMsg);
            } else {
                var data = result.AttachInfo;
                for (var i = 0; i < data[0].length; i++) {
                    var name = data[0][i].AttachName;
                    var value = data[0][i].AttachValue;

                    if (name == 'CreateTime') {
                        this.currDate = value;
                    } else if (name == 'InstantSpeed') { // 瞬时速度
                        this.speed = value;
                        this.gaugeHtml = this.getGaugeHtml(value / 4);
                    } else if (name == 'RotationRate') { // 发动机转速
                        this.rev = value;
                    } else if (name == 'ElectricTension') { // 电瓶电压
                        this.electricTension = this.getCircleHtml(value / 220 * 100, value + 'V', '#78DCF6');
                    } else if (name == 'EngineWeight') { // 发动机负荷
                        this.engineWeight = this.getCircleHtml(value / 400 * 100, value + '%', '#F79DF6');
                    } else if (name == 'CoolingLiquidTemperature') { // 冷却液温度
                        this.coolingLiquidTemperature = this.getCircleHtml(value / 2, value + '℃', '#F8CD9F');
                    } else if (name == 'InstantOilWear') { // 瞬时油耗
                        this.instantOilWear = this.getCircleHtml(value / 150 * 100, value + '<br/>ML/H', '#B6FFF2');
                    } else if (name == 'InletTemperature') { // 进气温度
                        this.inletTemperature = value;
                    } else if (name == 'AirFlux') { // 空气流量
                        this.airFlux = value;
                    } else if (name == 'InletPressure') { // 进气歧管绝对压力
                        this.inletPressure = value;
                    } else if (name == 'ThrottleValvePlace') { // 节气门位置
                        this.throttleValvePlace = value;
                    } else if (name == 'FuelOilPressure') { // 燃油压力计量
                        this.fuelOilPressure = value;
                    } else if (name == 'VINCode') { // VIN码
                        // 						if (value && value.length > 0) {
                        // 							this.VINCode = value.length + '位';
                        // 						}
                        this.VINCode = value;
                    } else if (name == 'TotalMileage') { // 总里程
                        this.totalMileage = value;
                    } else if (name == 'ContinuousMileage') { // 续航里程(KM)
                        this.continuousMileage = value;
                    } else if (name == 'PercentageOfOil') { // 油量百分比(%)
                        this.percentageOfOil = value;
                    }
                }
            }
        },
        onCheckResult: function (res) {
            var result = res;//JSON.parse(res);
            if (result.SucceedFlag != 0) {
                mui.alert(result.ErrorMsg);
            } else {
                var data = result.AttachInfo + "";
                var arr = data.split('|');
                this.hasBind = arr[0] == 0;
                if (this.hasBind) {
                    this.loadData();
                    mOpenAutoLoadData = true;
                } else {
                    mui.alert(arr[1]);
                }
            }
        },
        onSearchResult: function (res) {
            var result = res;//JSON.parse(res);
            if (result.SucceedFlag != 0) {
                mui.alert(result.ErrorMsg);
            } else {
                mOpenAutoLoadData = false;
                var data = result.AttachInfo;

                if (data && data.length > 0) {
                    onResultSucceed = true;
                    autoQueryGPSReportInfos(data);
                } else {
                    mui.alert('没有数据');
                }
            }
        },
        loadData: function () {
            EasymsPlugin.invoke('ECS_BusinessService', 'QueryGPSReportInfos',
                'System.String|System.Boolean', this.carNum + "|False", 'onResult');
        }
    },
    mounted: function () {
        window.onResult = this.onResult;
        window.onCheckResult = this.onCheckResult;
        window.onSearchResult = this.onSearchResult;
        this.carNum = getParamValue('carnum');

        this.gaugeHtml = this.getGaugeHtml(0);
        this.electricTension = this.getCircleHtml(0, '0V');
        this.engineWeight = this.getCircleHtml(0, '0%');
        this.coolingLiquidTemperature = this.getCircleHtml(0, '0℃');
        this.instantOilWear = this.getCircleHtml(0, '0ML/H');
    }
})

// 准备运行
var timerId = null;
function appMainEntry() {
    if (this.timeId) {
        clearTimeout(timeId);
        this.timerId = null;
    }
    try {
        try {
            if (EasymsPlugin.getDeviceType() >= 3) {
                if (EasymsPlugin.isiPhoneX() == 1) {
                    // iPhoneX 要多设顶部高度
                    document.getElementById("header").style.marginTop = "20px";
                }
            }
        } catch (e) {
            // 可能APP端还没有对应方法
        }
        var carNum = getParamValue('carnum');
        EasymsPlugin.invoke('ECS_BusinessService', 'CheckGPSHasDashboard', 'System.String', carNum, 'onCheckResult');
        autoLoadData();
    } catch (e2) {
        mui.alert(e2);
    }
}
timerId = setTimeout("appMainEntry()", 200);

var queryIndex = 0, queryInterval = null;
function autoQueryGPSReportInfos(data) {
    queryIndex = 0;
    queryInterval = setInterval(function () {
        if (queryIndex >= data.length) {
            clearInterval(queryInterval);
            mui.alert('回放结束');
            return;
        }
        if (onResultSucceed) {
            onResultSucceed = false;
            EasymsPlugin.invoke('ECS_BusinessService', 'QueryGPSReportInfos',
                'System.Int64|System.Boolean', data[queryIndex].POS_ID + '|False', 'onQueryGPSReportInfosResult');
            queryIndex++;
        }
    }, 1000);
}

function onQueryGPSReportInfosResult(res) {
    app.onResult(res);
}

var ald;

function autoLoadData() {
    clearInterval(ald);
    ald = setInterval(function () {
        if (mOpenAutoLoadData) {
            app.loadData();
        }
    }, 5000);
}

mui.init({
    swipeBack: true //启用右滑关闭功能
});
mui('.mui-scroll-wrapper').scroll({
    indicators: false
});

