﻿var app = new Vue({
    el: '#app',
    data: {
        items1: [],
        items2: [],
        items3: [],
        daysText: '近30天',
        monthText: '近一月'
    },
    mounted: function () {
        EasymsPlugin.loadData0('onResult0', 30);
        EasymsPlugin.loadData1('onResult1', 1);
        //将要给原生调用的方法挂载到 window 上面
        window.onResult0 = this.onResult0;
        window.onResult1 = this.onResult1;
    },
    methods: {
        onClickSelectDays: function (event) {
            var picker = new mui.PopPicker();
            picker.setData([
                { value: 7, text: '近7天' },
                { value: 30, text: '近30天' },
                { value: 90, text: '近三个月' },
                { value: 180, text: '近半年' },
                { value: 365, text: '一年内' }]);
            picker.show(function (selectItems) {
                console.log(selectItems[0].text);
                console.log(selectItems[0].value);
                app.$data.daysText = selectItems[0].text;
                EasymsPlugin.loadData0('onResult0', selectItems[0].value);
            })
        },
        onClickDetails1: function (event) {
            EasymsPlugin.toCarDetails();
        },
        onClickDetails2: function (event) {
            EasymsPlugin.toViolationDetails();
        },
        onClickSelectMohths: function (event) {
            var picker = new mui.PopPicker();
            picker.setData([
                { value: 1, text: '近一月' },
                { value: 3, text: '近三月' },
                { value: 6, text: '近半年' },
                { value: 12, text: '近一年' }]);
            picker.show(function (selectItems) {
                console.log(selectItems[0].text);
                console.log(selectItems[0].value);
                app.$data.monthText = selectItems[0].text;
                EasymsPlugin.loadData1('onResult1', selectItems[0].value);
            })
        },
        onClickMsgItem: function (name, type) {
            EasymsPlugin.toMessageActivity(name, type);
        },
        onResult0: function (res) {
            var jsonData = JSON.parse(res);
            if (jsonData.flag == 0) {
                var data = jsonData.data;
                // TOTAL_COUNT、INSURANCE_COUNT、REPAIR_COUNT、AUDIT_COUNT、BIND_COUNT、UNBIND_COUNT、ONLINE_COUNT、OFFNLINE_COUNT
                // 车辆总数、保险到期数、保养到期数、年检到期数、已绑定GPS数、未绑定GPS数、在线数、离线数
                var count0 = data[0][0].TOTAL_COUNT
                var count1 = data[0][0].INSURANCE_COUNT
                var count2 = data[0][0].REPAIR_COUNT
                var count3 = data[0][0].AUDIT_COUNT
                var count4 = data[0][0].BIND_COUNT
                var count5 = data[0][0].UNBIND_COUNT
                var count6 = data[0][0].ONLINE_COUNT
                var count7 = data[0][0].OFFNLINE_COUNT
                if (!count0 || count0 == 'null') count0 = 0
                if (!count1 || count1 == 'null') count1 = 0
                if (!count2 || count2 == 'null') count2 = 0
                if (!count3 || count3 == 'null') count3 = 0
                if (!count4 || count4 == 'null') count4 = 0
                if (!count5 || count5 == 'null') count5 = 0
                if (!count6 || count6 == 'null') count6 = 0
                if (!count7 || count7 == 'null') count7 = 0


                Vue.set(this.items1, 0, { count: count0, name: '车辆总数' })
                Vue.set(this.items1, 1, { count: count1, name: '保险到期数' })
                Vue.set(this.items1, 2, { count: count2, name: '保养到期数' })
                Vue.set(this.items1, 3, { count: count3, name: '年检到期数' })
                Vue.set(this.items1, 4, { count: count4, name: '已绑定GPS数' })
                Vue.set(this.items1, 5, { count: count5, name: '未绑定GPS数' })
                Vue.set(this.items1, 6, { count: count6, name: '在线数' })
                Vue.set(this.items1, 7, { count: count7, name: '离线数' })

                //TOTAL_COUNT、HANDLED_COUNT、UNHANDLE_COUNT、UNHANDLE_FEN、UNHANDLE_MONEY
                //车辆总数、已处理数、待处理数、待处理分数、待交罚款
                var number0 = data[1][0].HANDLED_COUNT
                var number1 = data[1][0].UNHANDLE_COUNT
                var number2 = data[1][0].UNHANDLE_FEN
                var number3 = data[1][0].UNHANDLE_MONEY
                if (!number0 || number0 == 'null') number0 = 0
                if (!number1 || number1 == 'null') number1 = 0
                if (!number2 || number2 == 'null') number2 = 0
                if (!number3 || number3 == 'null') number3 = 0

                Vue.set(this.items2, 0, { count: number0, name: '已处理数' })
                Vue.set(this.items2, 1, { count: number1, name: '待处理数' })
                Vue.set(this.items2, 2, { count: number2, name: '待处理分数' })
                Vue.set(this.items2, 3, { count: number3, name: '待交罚款' })

            } else {
                EasymsPlugin.toast(jsonData.message);
            }

            return jsonData.message;
        },
        onResult1: function (res) {
            var jsonData = JSON.parse(res);
            if (jsonData.flag == 0) {
                var data = jsonData.data;
                // BUSI_TYPE、BUSI_NAME、TOTAL_COUNT
                // 类别编号、类别名称、提醒数
                for (var i = 0; i < data.length; i++) {
                    var count = data[i].TOTAL_COUNT
                    if (!count || count == 'null') count = 0
                    Vue.set(this.items3, i, { count: count, name: data[i].BUSI_NAME, type: data[i].BUSI_TYPE })
                }
            } else {
                EasymsPlugin.toast(jsonData.message);
            }

            return jsonData.message;
        }
    }
})

function onResult1(res) {
    var jsonData = JSON.parse(res);
    if (res.flag == 0) {
        var data = res.data;
    }
}